function [c, ccons, lccons]=solvepolicyalt(model)
global  c cE x model fspace 
%disp('start solvepolicy.m')
%tic
%define function space
fspace=fundef({'lin',[0.01^(1-model.rho)/(1-model.rho),model.lmax^(1-model.rho)/(1-model.rho)],60},{'lin',model.istarvals2});
snodes=funnode(fspace);
s=gridmake(snodes);
%Print out discout factors
for d=1:model.di2
    delta_v(d)=model.r*model.beta*((model.G*model.N+model.R*model.istarvals2(d)*ones(size(model.N))).^(1-model.rho))'*model.w;
end
if max(delta_v)>1
    deltatoobig=max(delta_v)
    ccons=0;
    c=0;
    lccons=0;
else

    %initial guess
    imean=exp(model.Eistar+1/2*model.Varistar);
    xin=model.clbar*ones(size(s(:,1)));
    vin=s(:,1)+model.beta*(model.G+model.R*s(:,2)).^(1-model.rho)*((1).^(1-model.rho))/(1-model.rho)*(1/(1-model.beta*(model.G)^(1-model.rho)));

    %solve the dynamic problem by calculating the parameters c0 and c1
    [c,x,v] = dpsolvenewalt(model,fspace,snodes,s,vin,xin);
    ccons=funfitxy(fspace,snodes,x);
    lccons=funfitxy(fspace,snodes,log(x));
end;
%toc

