function vE = valfuncREalt(c,cE,s,fspace,model)
%disp('starting valfuncRE')
%diary off;
rho=model.rho;   beta=model.beta;   r=model.r;   R=model.R;         slbar=model.slbar;   G=model.G; clbar=model.clbar; slbar2=model.slbar2;
w=model.w;       e=model.e;

%define vectorized variables and variable sizes
K=length(w);
vE=zeros(size(s,1),1);
sav=((1-rho)*s(:,1)).^(1/(1-rho))+slbar*(s(:,2)==0)+slbar2*(s(:,2)>0)-0.01;   %offset things by 0.01 to avoid taking 0 to a negative power

for k=1:K
    vprime=zeros(size(sav));
    excliq=r*sav./(G*e(k,1)+R*s(:,2))+e(k,2)-slbar-clbar;
    excliq2=r*sav./(G*e(k,1)+R*s(:,2))+e(k,2)-slbar2-clbar;
    excliqin=excliq+0.01;
    excliq2in=excliq2+0.01;
    %people who default
    if size(vprime(excliq<0),1)>0 
        %disp('defaulters')
        vprime(excliq<0)=funeval(c,fspace,[(0.01*ones(size(excliq(excliq<0)))).^(1-rho)/(1-rho) zeros(size(excliq(excliq<0)))]);  
    end;
    %non-defaulters who can't afford to invest
    if size(vprime(excliq2<(e(k,3)) & excliq>=0),1)>0 
       % disp('non-defaulters,non-investors')
        vprime(excliq2<e(k,3) & excliq>=0)=funeval(c,fspace,[excliqin(excliq2<(e(k,3)) & excliq>=0).^(1-rho)/(1-rho) zeros(size(excliq(excliq2<(e(k,3)) & excliq>=0)))]);  
    end
    %non-defaulters who can afford to invest
    if size(vprime(excliq2>=(e(k,3)) & excliq>=0),1)>0 
        %disp('non-defaulters,potential investors')
        vprime(excliq2>=(e(k,3)) & excliq>=0)=max([funeval(c,fspace,[excliqin(excliq2>=(e(k,3)) & excliq>=0).^(1-rho)/(1-rho) zeros(size(excliq(excliq2>=(e(k,3)) & excliq>=0)))]) funeval(c,fspace,[(excliq2in(excliq2>=(e(k,3)) & excliq>=0)-e(k,3)).^(1-rho)/(1-rho) e(k,3)*ones(size(excliq(excliq2>=(e(k,3)) & excliq>=0)))])],[],2);
    end;
    vE=vE+beta*(G*e(k,1)+R*s(:,2)).^(1-rho).*vprime*w(k);
end;


