%This program calibrates the slbarmb values, and simulates the model
%under the MB program, and estimates the regression results in Table 5.
%It requires the data file Table5data.csv, outputs results in the files
%Table5coefficients.txt and Table5Chowtest.txt, and saves results under
%the file name millbahtwithsim.mat, which is needed for the long run
%simulations in longrun.m

!del Table5coefficients.txt Table5Chowtest.txt
clear all
global model fspace Ns1 Us1 istars1 valfunmb S1 alldata Ns2 Us2 istars2 Errs2 S2 cbase os zs e2 w2

thetahat=[0.0543    1.0465    0.0977    0.1787   -0.0825    0.5211    0.9257    1.1984    1.4663    6.2612    0.0224];


R=0.11;

alldata=load('Table5data.csv');
nHH=length(alldata(:,1));
model.r=1+real(thetahat(1));
model.G=real(thetahat(2));
model.VarN=real(thetahat(3));
model.Varu=real(thetahat(4));
model.slbar=real(thetahat(5));
model.clbar=real(thetahat(6));
model.beta=real(thetahat(7));
model.rho=real(thetahat(8));
model.Eistar=real(thetahat(9));
model.Varistar=real(thetahat(10));
model.VarErr=real(thetahat(11));
model.R=R;
d=4;
%set other parameters of the model
model.maxit=300;  model.tol=0.0001;
model.dN=4;
model.du=4;
model.di=8;        % number of i points for Gaussian quadrature integration 
model.di2=model.di+1;
[model.e, model.w]=qnwlogn([model.dN,model.du,model.di],[0 0 model.Eistar],[model.VarN 0 0; 0 model.Varu 0; 0 0 model.Varistar]);
[model.istarvals, istarweight]=qnwlogn(model.di,model.Eistar,model.Varistar);
%get weights and values for u and istar for expectation calculations
%discretize the random shocks e=[N,u,istar]
model.N=model.e(:,1);
model.u=model.e(:,2);
model.istar=model.e(:,3);
model.istarvals2=[0;model.istarvals];
model.di2=length(model.istarvals2);
model.lmax=max(alldata(:,21)./alldata(:,5))*model.e(end,2);
slbarvecmb=zeros(nHH,1);

% set amount of credit
intervention=950000;
%now solve optimal baseline policy
[e2, w2]=qnwlogn([8,8,2],[0 model.Eistar 0],[model.Varu 0 0; 0 model.Varistar 0; 0 0 model.VarErr]);
S2=700;
Ns2=exp(model.VarN^0.5*randn(nHH,S2,2));
Us2=exp(model.Varu^0.5*randn(nHH,S2,3));
Errs2=exp(model.VarErr^0.5*randn(nHH,S2,3));
istars2=exp(model.Varistar^0.5*randn(nHH,S2,2)+model.Eistar);
numslbar=40;
slbarbase=model.slbar;
slbargrid=linspace(model.slbar-0.02,model.slbar-1.1,numslbar);
mbgridnum=ones(nHH,1);
valfunmb=mbgridnum;
diffhold=ones(64,1)*50000000000000000000000000;
[c ccons lccons]=solvepolicya(model);
cbase=c;
cmat=zeros(length(c),numslbar);
cconsmat=zeros(length(c),numslbar);
%initialize variable sizes
zs=zeros(nHH,1);
os=ones(nHH,1);
d=zeros(nHH,1);
iable=zeros(nHH,1);
s=zeros(nHH,1);
L=s;
Y=s;
C=s;
Bbase=s;
B=s;
sb=zeros(nHH,1);
sss=zeros(nHH,1);
valholder=s;
valfunbasetemp=s;
valfunbase=s;
valfunmbtemp=s;
valfunmbss=s;
def6=zeros(nHH,S2);
Y6=zeros(nHH,S2);
L6=zeros(nHH,S2);
d6=zeros(nHH,S2);
C6=zeros(nHH,S2);
I6=zeros(nHH,S2);
def7=zeros(nHH,S2);
Y7=zeros(nHH,S2);
L7=zeros(nHH,S2);
d7=zeros(nHH,S2);
C7=zeros(nHH,S2);
I7=zeros(nHH,S2);

%we'll leave data in matrix form for routines, but use this as a key:

% Y1=alldata(:,1);
% Y2=alldata(:,2);
% Y3=alldata(:,3);
% Y4=alldata(:,4);
% Y5=alldata(:,5);
% Y6=alldata(:,6);
% Y7=alldata(:,7);
% I1=alldata(:,8);
% I2=alldata(:,9);
% I3=alldata(:,10);
% I4=alldata(:,11);
% I5=alldata(:,12);
% I6=alldata(:,13);
% I7=alldata(:,14);
% DEF2=alldata(:,15);
% DEF3=alldata(:,16);
% DEF4=alldata(:,17);
% DEF5=alldata(:,18);
% DEF6=alldata(:,19);
% DEF7=alldata(:,20);
% L2=alldata(:,21);
% L3=alldata(:,22);
% L4=alldata(:,23);
% L5=alldata(:,24);
% L6=alldata(:,25);
% L7=alldata(:,26);
% C2=alldata(:,27);
% C3=alldata(:,28);
% C4=alldata(:,29);
% C5=alldata(:,30);
% C6=alldata(:,31);
% C7=alldata(:,32);
% villnum=alldata(:,33)
% villsize=alldata(:,34)

for ss=1:numslbar
     model.slbar=slbargrid(ss);
     [cmat(:,ss) cconsmat(:,ss) lccons]=solvepolicya(model);
end

model.slbar=slbarbase;
for t=2:5
    for k=1:128
        %let's figure out 2002 predictions for different slbars
        Y=alldata(:,t);
        L=alldata(:,19+t);
        U=e2(k,1);
        ist=e2(k,2);
        UE=U*e2(k,3);
        def=(L./Y.*UE<(model.slbar+model.clbar));
        iable=(L./Y.*UE>=model.slbar+model.clbar+ist);
        %do for defaulters  (just need consumption)
        if max(def)==1
            sb(def==1)=model.slbar*Y(def==1)./(UE);
            if t==5
                valfunbasetemp(def==1)=funeval(c,fspace,[(0.01*os(def==1,1)).^(1-model.rho)/(1-model.rho)  zs(def==1,1)]).*((Y(def==1)/UE).^(1-model.rho));
            end
        end
        %do for non-investors
        if max(iable==0 & def==0)==1
            C(iable==0 & def==0)=funeval(ccons,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*Y(iable==0 & def==0)/UE;
            sb(iable==0 & def==0)=L(iable==0 & def==0)-C(iable==0 & def==0);
            if t==5
                valfunbasetemp(iable==0 & def==0)=funeval(c,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*((Y(iable==0 & def==0)/UE).^(1-model.rho));        
            end
        end
        %do for potential investors
        if max(iable)==1
            [valholder(iable==1) d(iable==1)]=max([funeval(c,fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) funeval(c,fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1,1)])],[],2);
            d(iable==1)=d(iable==1)-1;
            C(iable==1)=((1-d(iable==1)).*funeval(ccons,fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) + d(iable==1).*funeval(ccons,fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1,1)])).*Y(iable==1)/UE;           
            sb(iable==1)=L(iable==1)-C(iable==1)-ist*d(iable==1).*Y(iable==1)/UE;
            if t==5
               valfunbasetemp(iable==1)=valholder(iable==1).*((Y(iable==1)/UE).^(1-model.rho));
            end
        end         
        Bbase=Bbase-(sb<0).*sb*w2(k)*1/4;
        if t==5
            valfunbase=valfunbase+valfunbasetemp*w2(k);
        end
    end
end
for ss=1:numslbar
    B=zeros(nHH,1);
    sss=zeros(nHH,1);
    valfunmbss=B;
    model.slbar=slbargrid(ss);
    for t=2:5
        for k=1:128
            %let's figure out 2002 predictions for different slbars
            Y=alldata(:,t);
            L=alldata(:,19+t);
            U=e2(k,1);
            ist=e2(k,2);
            UE=U*e2(k,3);
            def=(L./Y.*UE<(model.slbar+model.clbar));
            iable=(L./Y.*UE>model.slbar+model.clbar+ist);
            %do for defaulters  (just need consumption)
            if max(def)==1
                sss(def==1)=model.slbar*Y(def==1)./UE;
                if t==5
                    valfunmbtemp(def==1)=funeval(cmat(:,ss),fspace,[(0.01*os(def==1,1)).^(1-model.rho)/(1-model.rho)  zs(def==1,1)]).*((Y(def==1)/UE).^(1-model.rho));
                end
            end
            %do for non-investors
            if max(iable==0 & def==0)==1
                C(iable==0 & def==0)=funeval(cconsmat(:,ss),fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*Y(iable==0 & def==0)/UE;
                sss(iable==0 & def==0)=L(iable==0 & def==0)-C(iable==0 & def==0);
                if t==5
                    valfunmbtemp(iable==0 & def==0)=funeval(cmat(:,ss),fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*((Y(iable==0 & def==0)/UE).^(1-model.rho));
                end
            end
            %do for potential investors
            if max(iable)==1
                [valholder(iable==1) d(iable==1)]=max([funeval(cmat(:,ss),fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) funeval(cmat(:,ss),fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1,1)])],[],2);
                d(iable==1)=d(iable==1)-1;
                C(iable==1)=((1-d(iable==1)).*funeval(cconsmat(:,ss),fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) + d(iable==1).*funeval(cconsmat(:,ss),fspace,[(L(iable==1)./Y(iable==1)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1,1)])).*Y(iable==1)./UE;           
                sss(iable==1)=L(iable==1)-C(iable==1)-ist*d(iable==1).*Y(iable==1)/UE;
                if t==5
                    valfunmbtemp(iable==1)=valholder(iable==1).*((Y(iable==1)./UE).^(1-model.rho));
                end
            end         
            if t==5
                valfunmbss=valfunmbss+valfunmbtemp*w2(k);
            end
            B=B-(sss<0).*sss*w2(k)*1/4;
        end
    end
    for v=1:64
         diff=mean(B-Bbase)*mean(alldata(alldata(:,33)==v,34))-intervention;
         if diff<diffhold(v)
             diffhold(v)=abs(diff);
             mbgridnum(alldata(:,33)==v)=ss;
             valfunmb(alldata(:,33)==v)=valfunmbss(alldata(:,33)==v);
             slbarmb(v)=slbargrid(ss);
        end
    end            
end

diary calibratedslbar.txt
meanslbarmb=mean(slbarmb)
stddevslbarmb=std(slbarmb)
diary off

for ss=1:numslbar
    model.slbar=slbargrid(ss);
    if (max(mbgridnum==ss)>0)      
        %calculate baselineconsumption, investment, and savings
        for k=1:S2
            %let's figure out 2002 predictions
            Y6(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,1).*alldata(mbgridnum==ss,5)./(Us2(mbgridnum==ss,k,1).*Errs2(mbgridnum==ss,k,1))+model.R*alldata(mbgridnum==ss,12)).*Us2(mbgridnum==ss,k,2);
            L6(mbgridnum==ss,k)=(alldata(mbgridnum==ss,21)-alldata(mbgridnum==ss,25)-alldata(mbgridnum==ss,12)).*model.r+Y6(mbgridnum==ss,k);
            def6(mbgridnum==ss,k)=(L6(mbgridnum==ss,k)./Y6(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,2)<(model.slbar+model.clbar));
            sdef6(mbgridnum==ss,k)=L6(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y6(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,2);
            iable(mbgridnum==ss)=(L6(mbgridnum==ss,k)./Y6(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,2)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,1)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def6(:,k)==1)==1
                d6(mbgridnum==ss & def6(:,k)==1,k)=0;
                C6(mbgridnum==ss & def6(:,k)==1,k)=model.clbar*Y6(mbgridnum==ss & def6(:,k)==1,k)./(Us2(mbgridnum==ss & def6(:,k)==1,k,2));
                s6(mbgridnum==ss & def6(:,k)==1,k)=model.slbar*Y6(mbgridnum==ss & def6(:,k)==1,k)./(Us2(mbgridnum==ss & def6(:,k)==1,k,2));
            end
            %do for non-investors
                if max(mbgridnum==ss & iable==0 & def6(:,k)==0)==1
                d6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)=0;
                C6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)./Y6(mbgridnum==ss & iable==0 & def6(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def6(:,k)==0,k,2)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def6(:,k)==0,1)]).*Y6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def6(:,k)==0,k,2);
                s6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)=L6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)-C6(mbgridnum==ss & iable==0 & def6(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d6(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,1)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,1)])],[],2);
                d6(mbgridnum==ss & iable==1,k)=d6(mbgridnum==ss & iable==1,k)-1;
                C6(mbgridnum==ss & iable==1,k)=((1-d6(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d6(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,1)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,1)])).*Y6(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,2);
                s6(mbgridnum==ss & iable==1,k)=L6(mbgridnum==ss & iable==1,k)-C6(mbgridnum==ss & iable==1,k)-d6(mbgridnum==ss & iable==1,k).*istars2(mbgridnum==ss & iable==1,k,1).*Y6(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,2);
            end
            I6(mbgridnum==ss,k)=d6(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,1).*Y6(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,2);
            Y7(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,2)+model.R*d6(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,1)).*Y6(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,3)./Us2(mbgridnum==ss,k,2);
            L7(mbgridnum==ss,k)=s6(mbgridnum==ss,k).*model.r+Y7(mbgridnum==ss,k);
            def7(mbgridnum==ss,k)=(L7(mbgridnum==ss,k)./Y7(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,3)<(model.slbar+model.clbar));
            sdef7(mbgridnum==ss,k)=L7(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y7(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,3);
            iable(mbgridnum==ss)=(L7(mbgridnum==ss,k)./Y7(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,3)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,2)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def7(:,k)==1)==1
                d7(mbgridnum==ss & def7(:,k)==1,k)=0;
                C7(mbgridnum==ss & def7(:,k)==1,k)=model.clbar*Y7(mbgridnum==ss & def7(:,k)==1,k)./Us2(mbgridnum==ss & def7(:,k)==1,k,3);
                s7(mbgridnum==ss & def7(:,k)==1,k)=model.slbar*Y7(mbgridnum==ss & def7(:,k)==1,k)./Us2(mbgridnum==ss & def7(:,k)==1,k,3);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def7(:,k)==0)==1
                d7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)=0;
                C7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)./Y7(mbgridnum==ss & iable==0 & def7(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def7(:,k)==0,k,3)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def7(:,k)==0,1)]).*Y7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def7(:,k)==0,k,3);
                s7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)=L7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)-C7(mbgridnum==ss & iable==0 & def7(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d7(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,2)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,2)])],[],2);
                d7(mbgridnum==ss & iable==1,k)=d7(mbgridnum==ss & iable==1,k)-1;
                C7(mbgridnum==ss & iable==1,k)=((1-d7(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d7(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,2)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,2)])).*Y7(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,3);
                s7(mbgridnum==ss & iable==1,k)=L7(mbgridnum==ss & iable==1,k)-C7(mbgridnum==ss & iable==1,k)-d7(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,2).*Y7(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,3);
            end
            I7(mbgridnum==ss,k)=d7(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,2).*Y7(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,3);
        end
    end
end

%now add in the measurement error
for k=1:S2
    Y6(:,k)=Y6(:,k).*Errs2(:,k,2);
    Y7(:,k)=Y7(:,k).*Errs2(:,k,3);
end
C6mb=(sum(C6(:,:),2))/(length(C6(1,:)));
C7mb=(sum(C7(:,:),2))/(length(C7(1,:)));
Cmb=(sum(C6(:,:),2)+sum(C7(:,:),2))/(2*length(C6(1,:)));
I6mb=(sum(I6(:,:),2))/(length(I6(1,:)));
I7mb=(sum(I7(:,:),2))/(length(I7(1,:)));
Imb=(sum(I6(:,:),2)+sum(I7(:,:),2))/(2*length(I6(1,:)));
S6mb=(sum(s6(:,:),2))/(length(s6(1,:)));
S7mb=(sum(s7(:,:),2))/(length(s7(1,:)));
Smb=(sum(s6(:,:),2)+sum(s7(:,:),2))/(2*length(s6(1,:)));
sdef6mb=(sum((sdef6(:,:).*(sdef6<0)),2))/(length(sdef6(1,:)));
sdef7mb=(sum((sdef7(:,:).*(sdef7<0)),2))/(length(sdef7(1,:)));
sdefmb=(sum((sdef6(:,:).*(sdef6<0)),2)+sum((sdef7(:,:).*(sdef7<0)),2))/(2*length(sdef6(1,:)));
B6mb=(sum((s6(:,:).*(s6<0)),2))/(length(s6(1,:)));
B7mb=(sum((s7(:,:).*(s7<0)),2))/(length(s7(1,:)));
Bmb=(sum((s6(:,:).*(s6<0)),2)+sum((s7(:,:).*(s7<0)),2))/(2*length(s6(1,:)));

Ydata=reshape(alldata(:,2:7),[],1);
Ygrowthdata=reshape(log(alldata(:,2:7)./alldata(:,1:6)),[],1);
Idata=reshape(alldata(:,9:14),[],1);
Ddata=reshape((alldata(:,9:14)>ones(nHH,6)),[],1);
DEFdata=reshape(alldata(:,15:20),[],1);
Cdata=reshape(alldata(:,27:32),[],1);
%KEY: X=[invHH*year==2002 invHH*year==2003  year==1998 year==1999 year==2000 year==2001  year==2002 year==2003]
X=[zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1)];

%FIRST WE DO EVERYTHING ONLY USING THE DATA
%now run regressions;
betaCd=inv(X'*X)*X'*Cdata;
sig2Cd=mean((Cdata-X*betaCd).^2);
stdbetaCd=diag(sig2Cd*inv(X'*X)).^0.5;
betaDd=inv(X'*X)*X'*Ddata;
sig2Dd=mean((Ddata-X*betaDd).^2);
stdbetaDd=diag(sig2Dd*inv(X'*X)).^0.5;
betaId=inv(X'*X)*X'*Idata;
sig2Id=mean((Idata-X*betaId).^2);
stdbetaId=diag(sig2Id*inv(X'*X)).^0.5;
betaDEFd=inv(X'*X)*X'*DEFdata;
sig2DEFd=mean((DEFdata-X*betaDEFd).^2);
stdbetaDEFd=diag(sig2DEFd*inv(X'*X)).^0.5;
betaYgrowthd=inv(X'*X)*X'*Ygrowthdata;
sig2Ygrowthd=mean((Ygrowthdata-X*betaYgrowthd).^2);
stdbetaYgrowthd=diag(sig2Ygrowthd*inv(X'*X)).^0.5; 
  
%NOW WE REDO EVERYTHING WITH SIMULATED DATA

for k=1:S2
    Ym=[Ydata(1:4*nHH);Y6(:,k);Y7(:,k)];
    Yp=[Ydata;Y6(:,k);Y7(:,k)];
    Ygrowthm=[Ygrowthdata(1:4*nHH); log(Y6(:,k)./alldata(:,5)); log(Y7(:,k)./Y6(:,k))];
    Ygrowthp=[Ygrowthdata;log(Y6(:,k)./alldata(:,5)); log(Y7(:,k)./Y6(:,k))];
    Im=[Idata(1:4*nHH); I6(:,k); I7(:,k)];
    Ip=[Idata;I6(:,k);I7(:,k)];
    Dm=[Ddata(1:4*nHH); d6(:,k); d7(:,k)];
    Dp=[Ddata;d6(:,k);d7(:,k)];
    DEFm=[DEFdata(1:4*nHH); def6(:,k); def7(:,k)];
    DEFp=[DEFdata;def6(:,k);def7(:,k)];
    Cm=[Cdata(1:4*nHH);C6(:,k);C7(:,k)];
    Cp=[Cdata;C6(:,k);C7(:,k)];
    
    %now run regressions
    betaCm(:,k)=inv(X'*X)*X'*Cm;
    sig2Cm=mean((Cm-X*betaCm(:,k)).^2);
    stdbetaCm(:,k)=diag(sig2Cm*inv(X'*X)).^0.5;
    betaDm(:,k)=inv(X'*X)*X'*Dm;
    sig2Dm=mean((Dm-X*betaDm(:,k)).^2);
    stdbetaDm(:,k)=diag(sig2Dm*inv(X'*X)).^0.5;
    betaIm(:,k)=inv(X'*X)*X'*Im;
    sig2Im=mean((Im-X*betaIm(:,k)).^2);
    stdbetaIm(:,k)=diag(sig2Im*inv(X'*X)).^0.5;
    betaIonlym(:,k)=inv(X(Dm==1,:)'*X(Dm==1,:))*X(Dm==1,:)'*Im(Dm==1);
    sig2Ionlym=mean((Im(Dm==1)-X(Dm==1,:)*betaIonlym(:,k)).^2);
    stdbetaIonlym(:,k)=diag(sig2Ionlym*inv(X(Dm==1,:)'*X(Dm==1,:))).^0.5;
    betaDEFm(:,k)=inv(X'*X)*X'*DEFm;
    sig2DEFm=mean((DEFm-X*betaDEFm(:,k)).^2);
    stdbetaDEFm(:,k)=diag(sig2DEFm*inv(X'*X)).^0.5;
    betaYgrowthm(:,k)=inv(X'*X)*X'*Ygrowthm;
    sig2Ygrowthm=mean((Ygrowthm-X*betaYgrowthm(:,k)).^2);
    stdbetaYgrowthm(:,k)=diag(sig2Ygrowthm*inv(X'*X)).^0.5; 
 end;
diary Table5coefficients.txt;


comparebetaCm=[mean(stdbetaCm,2) mean(betaCm,2) stdbetaCd betaCd];
comparebetaCmmain1=comparebetaCm(1,:)   %1st year coefficients
comparebetaCmmain2=comparebetaCm(2,:)   %2nd year coefficients
comparebetaDm=[mean(stdbetaDm,2) mean(betaDm,2) stdbetaDd betaDd];
comparebetaDmmain1=comparebetaDm(1,:)   %1st year coefficients
comparebetaDmmain2=comparebetaDm(2,:)   %2nd year coefficients
comparebetaIm=[mean(stdbetaIm,2) mean(betaIm,2) stdbetaId betaId];
comparebetaImmain1=comparebetaIm(1,:)   %1st year coefficients
comparebetaImmain2=comparebetaIm(2,:)   %2nd year coefficients
comparebetaDEFm=[mean(stdbetaDEFm,2) mean(betaDEFm,2) stdbetaDEFd betaDEFd];
comparebetaDEFmmain1=comparebetaDEFm(1,:)       %1st year coefficients
comparebetaDEFmmain2=comparebetaDEFm(2,:)       %2nd year coefficients
comparebetaYgrowthm=[mean(stdbetaYgrowthm,2) mean(betaYgrowthm,2) stdbetaYgrowthd betaYgrowthd];
comparebetaYgrowthmmain1=comparebetaYgrowthm(1,:)   %1st year coefficients
comparebetaYgrowthmmain2=comparebetaYgrowthm(2,:)   %2nd year coefficients



diary off;


save millbahtwithsim;

%Okay, now get enough free memory to perform Chow test

save matforchow alldata Cdata Ddata Idata DEFdata Ygrowthdata intervention S2 nHH C6 C7 d6 d7 I6 I7 def6 def7 Y6 Y7;
clear;
load matforchow;
 %Xp2=[year=1 data, year=2 data, year=1 model, year=2 model, year=1 villsize both, year=2 villsize both];
 Xp1=[ones(nHH,1) zeros(nHH,3) intervention./alldata(:,34) zeros(nHH,1);
      zeros(nHH,1) ones(nHH,1) zeros(nHH,3) intervention./alldata(:,34);
      zeros(S2*nHH,2) ones(S2*nHH,1) zeros(S2*nHH,1) kron(intervention./alldata(:,34),ones(S2,1)) zeros(S2*nHH,1);
      zeros(S2*nHH,3) ones(S2*nHH,1) zeros(S2*nHH,1) kron(intervention./alldata(:,34),ones(S2,1))];
 Xp2=[ones(nHH,1) zeros(nHH,3) intervention./alldata(:,34) zeros(nHH,3);
      zeros(nHH,1) ones(nHH,1) zeros(nHH,3) intervention./alldata(:,34) zeros(nHH,2);
      zeros(S2*nHH,2) ones(S2*nHH,1) zeros(S2*nHH,3) kron(intervention./alldata(:,34),ones(S2,1)) zeros(S2*nHH,1);
      zeros(S2*nHH,3) ones(S2*nHH,1) zeros(S2*nHH,3) kron(intervention./alldata(:,34),ones(S2,1))];
  Cp2=[Cdata(4*nHH+1:end); reshape(C6,[],1); reshape(C7,[],1)];
  Dp2=[Ddata(4*nHH+1:end); reshape(d6,[],1); reshape(d7,[],1)];
  Ip2=[Idata(4*nHH+1:end); reshape(I6,[],1); reshape(I7,[],1)];
  DEFp2=[DEFdata(4*nHH+1:end); reshape(def6,[],1); reshape(def7,[],1)];
  Ygrowthp2=[Ygrowthdata(4*nHH+1:end); log(reshape(Y6,[],1)./kron(alldata(:,6),ones(S2,1))); log(reshape(Y7,[],1)./reshape(Y6,[],1))];
  
  %now calculate Chows
    betaCp1=inv(Xp1'*Xp1)*Xp1'*Cp2;
    betaCp2=inv(Xp2'*Xp2)*Xp2'*Cp2;
    SSEC(1)=sum((Cp2-Xp2*betaCp2).^2);
    SSECp(1)=sum((Cp2-Xp1*betaCp1).^2);
    CHOWtest(1)=((SSECp(1)-SSEC(1))/SSEC(1)*(S2+2)*nHH/2);
    betaDp1=inv(Xp1'*Xp1)*Xp1'*Dp2;
    betaDp2=inv(Xp2'*Xp2)*Xp2'*Dp2;
    SSEC(2)=sum((Dp2-Xp2*betaDp2).^2);
    SSECp(2)=sum((Dp2-Xp1*betaDp1).^2);
    CHOWtest(2)=((SSECp(2)-SSEC(2))/SSEC(2)*(S2+2)*nHH/2);
    betaIp1=inv(Xp1'*Xp1)*Xp1'*Ip2;
    betaIp2=inv(Xp2'*Xp2)*Xp2'*Ip2;
    SSEC(3)=sum((Ip2-Xp2*betaIp2).^2);
    SSECp(3)=sum((Ip2-Xp1*betaIp1).^2);
    CHOWtest(3)=((SSECp(3)-SSEC(3))/SSEC(3)*(S2+2)*nHH/2);
    betaDEFp1=inv(Xp1'*Xp1)*Xp1'*DEFp2;
    betaDEFp2=inv(Xp2'*Xp2)*Xp2'*DEFp2;
    SSEC(4)=sum((DEFp2-Xp2*betaDEFp2).^2);
    SSECp(4)=sum((DEFp2-Xp1*betaDEFp1).^2);
    CHOWtest(4)=((SSECp(4)-SSEC(4))/SSEC(4)*(S2+2)*nHH/2);
    betaYgrowthp1=inv(Xp1'*Xp1)*Xp1'*Ygrowthp2;
    betaYgrowthp2=inv(Xp2'*Xp2)*Xp2'*Ygrowthp2;
    SSEC(5)=sum((Ygrowthp2-Xp2*betaYgrowthp2).^2);
    SSECp(5)=sum((Ygrowthp2-Xp1*betaYgrowthp1).^2);
    CHOWtest(5)=((SSECp(5)-SSEC(5))/SSEC(5)*(S2+2)*nHH/2);

    diary Table5Chowtest.txt
    CHOWtest=CHOWtest
    diary off


        
 
