function [eps] = separatemomentslevels_fullsample(theta)

global fulldata nHH fspace model R

%assign parameter values
model.r=1+real(theta(1));
model.G=real(theta(2));
model.VarN=real(theta(3));
model.Varu=real(theta(4));
slbarbase=real(theta(5));
slbarshift=real(theta(6));
slbarcon=real(theta(7));
slbarHH=real(theta(8));
model.clbar=real(theta(9));
model.beta=real(theta(10));
model.rho=real(theta(11));
model.Eistar=real(theta(12));
model.Varistar=real(theta(13));
model.VarErr=real(theta(14));
model.R=R;
d=4;

villsize=fulldata(:,58);
%set other parameters of the model
model.maxit=300;  model.tol=0.0001;
model.dN=4;
model.du=4;
model.di=8;        % number of i points for Gaussian quadrature integration 
model.di2=model.di+1;
[model.e, model.w]=qnwlogn([model.dN,model.du,model.di],[0 0 model.Eistar],[model.VarN 0 0; 0 model.Varu 0; 0 0 model.Varistar]);
[model.istarvals, istarweight]=qnwlogn(model.di,model.Eistar,model.Varistar);

%discretize the random shocks e=[N,u,istar], VarN should be 0.26, varu should be 0.36

model.N=model.e(:,1);
model.u=model.e(:,2);
model.istar=model.e(:,3);
model.istarvals2=[0;model.istarvals];
model.di2=length(model.istarvals2);
model.lmax=max(fulldata(:,3)./fulldata(:,2))*model.e(end,2);

%get weights and values for u and istar for expectation calculations
[Sval,Sw]=qnwlogn([d d d],[0 model.Eistar 0],[model.Varu 0 0; 0 model.Varistar 0; 0 0 model.VarErr]);
ds=length(Sw);
S=100;


%initialize size of vectors for moment calculations below
eps=zeros(nHH,27);
def=zeros(nHH,1);
iable=zeros(nHH,1);
d=zeros(nHH,5,ds);
Clevel=zeros(nHH,7,ds);
dIlevel=zeros(nHH,7,ds);
EClev=zeros(nHH,7);
Ed=zeros(nHH,7);
EdIlev=zeros(nHH,7);
dp=zeros(nHH,1);
C=zeros(nHH,1);
Yprime=ones(nHH,6,S);
Y2prime=ones(nHH,5,S);
Y3prime=ones(nHH,2,S);
Lprime=zeros(nHH,S);
L2prime=zeros(nHH,S);
L3prime=zeros(nHH,S);
L4prime=zeros(nHH,S);
ElnYp=zeros(nHH,6);
ElnY2p=zeros(nHH,5);
ElnY3p=zeros(nHH,2);
sqdevlnYp=zeros(nHH,6,S);
sqdevlnY2p=zeros(nHH,5,S);
sqdevlnY3p=zeros(nHH,2,S);
EvarlnYp=zeros(nHH,6);
EvarlnY2p=zeros(nHH,5);
EvarlnY3p=zeros(nHH,2);
s=zeros(nHH,1);

%now get vectors we will need for calculations
zs=zeros(nHH,1);
os=ones(nHH,1);

%next we solve for the policy function using theta
model.slbar=slbarbase;
[c ccons lccons]=solvepolicy(model);
cmb=zeros(length(c),64);
if length(c)==1 
    eps=ones(nHH,27)*1000000000;
else
    for jj=1:64
        slbarmb(jj)=slbarshift+slbarcon*mean(fulldata(fulldata(:,57)==jj,58))^slbarHH;
        model.slbar=slbarmb(jj);
        [cmb(:,jj) cconsmb(:,jj) lccons]=solvepolicy(model);
    end

    %we'll leave data in matrix form for routines, but use this as a key:
    % Y1=fulldata(:,1);
    % Y2=fulldata(:,2);
    % Y3=fulldata(:,3);
    % Y4=fulldata(:,4);
    % Y5=fulldata(:,5);
    % Y6=fulldata(:,6);  
    % Y7=fulldata(:,7);
    % I1=fulldata(:,8);
    % I2=fulldata(:,9);
    % I3=fulldata(:,10);
    % I4=fulldata(:,11);
    % I5=fulldata(:,12);
    % I6=fulldata(:,13);
    % I7=fulldata(:,14);
    % INT2=fulldata(:,15);
    % INT3=fulldata(:,16);
    % INT4=fulldata(:,17);
    % INT5=fulldata(:,18);
    % INT6=fulldata(:,19);
    % INT7=fulldata(:,20);
    % S1=fulldata(:,21);
    % S2=fulldata(:,22); 
    % S3=fulldata(:,23);
    % S4=fulldata(:,24);
    % S5=fulldata(:,25);
    % S6=fulldata(:,26);
    % STINT2=fulldata(:,27);
    % STINT3=fulldata(:,28);
    % STINT4=fulldata(:,29);
    % STINT5=fulldata(:,30);
    % STINT6=fulldata(:,31);
    % STINT7=fulldata(:,32);
    % ST1=fulldata(:,33);
    % ST2=fulldata(:,34);
    % ST3=fulldata(:,35);
    % ST4=fulldata(:,36);
    % ST5=fulldata(:,37);
    % ST6=fulldata(:,38);
    % DEF2=fulldata(:,39);
    % DEF3=fulldata(:,40);
    % DEF4=fulldata(:,41);
    % DEF5=fulldata(:,42);
    % DEF6=fulldata(:,43);
    % DEF7=fulldata(:,44);
    % L2=fulldata(:,45);
    % L3=fulldata(:,46);
    % L4=fulldata(:,47);
    % L5=fulldata(:,48);
    % L6=fulldata(:,49);
    % L7=fulldata(:,50);
    % C2=fulldata(:,51);
    % C3=fulldata(:,52);
    % C4=fulldata(:,53);
    % C5=fulldata(:,54);
    % C6=fulldata(:,55);
    % C7=fulldata(:,56);
    % villnum=fulldata(:,57);
    % villsize=fulldata(:,58);

    
Ns=exp(model.VarN^0.5*randn(nHH,S,5));
Us=exp(model.Varu^0.5*randn(nHH,S,6));
Errs=exp(model.VarErr^0.5*randn(nHH,S,6));
istars=exp(model.Varistar^0.5*randn(nHH,S,5)+model.Eistar);


    for t=2:5     
        %let's calculate current investment decisions, investment, and
        %consumption conditional on current shocks using baseline borrowing
        if t<=5
            for j=1:ds
                ya=fulldata(:,t)/Sval(j,3);
                la=(fulldata(:,43+t)-fulldata(:,t))+ya;
                def=(la./ya*Sval(j,1)<(model.slbar+model.clbar));
                iable=(la./ya*Sval(j,1)>model.slbar+model.clbar+Sval(j,2));
                %do for defaulters  (just need consumption)
                if max(def)==1
                    Clevel(def==1,t,j)=model.clbar*ya(def==1)/Sval(j,1);
                    d(def==1,t,j)=0;
                end
                %do for non-investors
                if max(iable==0 & def==0)==1
                    d(iable==0 & def==0,t,j)=0;
                    Clevel(iable==0 & def==0,t,j)=funeval(ccons,fspace,[(la(iable==0 & def==0)./ya(iable==0 & def==0)*Sval(j,1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*ya(iable==0 & def==0)/Sval(j,1);
                end
                %do for potential investors
                if max(iable)==1
                    [valfun d(iable==1,t,j)]=max([funeval(c,fspace,[(la(iable==1)./ya(iable==1)*Sval(j,1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) funeval(c,fspace,[(la(iable==1)./ya(iable==1)*Sval(j,1)-model.slbar-model.clbar+0.01-Sval(j,2)).^(1-model.rho)/(1-model.rho)  Sval(j,2)*os(iable==1)])],[],2);
                    d(iable==1,t,j)=d(iable==1,t,j)-1;
                    Clevel(iable==1,t,j)=((1-d(iable==1,t,j)).*funeval(ccons,fspace,[(la(iable==1)./ya(iable==1)*Sval(j,1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) + d(iable==1,t,j).*funeval(ccons,fspace,[(la(iable==1)./ya(iable==1)*Sval(j,1)-model.slbar-model.clbar+0.01-Sval(j,2)).^(1-model.rho)/(1-model.rho)  Sval(j,2)*os(iable==1)])).*ya(iable==1)/Sval(j,1);
                end
                %now calculate log investment and investment levels
                dIlevel(:,t,j)=d(:,t,j).*(Sval(j,2)*ya(:)/Sval(j,1));
                EClev(:,t)=EClev(:,t)+Clevel(:,t,j)*Sw(j);
                Ed(:,t)=Ed(:,t)+d(:,t,j)*Sw(j);
                EdIlev(:,t)=EdIlev(:,t)+dIlevel(:,t,j)*Sw(j);
            end
            if t<=4
                for k=1:S
                    ya=fulldata(:,t)./Errs(:,k,t-1);
                    la=(fulldata(:,43+t)-fulldata(:,t))+ya;
                    def=(la./ya.*Us(:,k,t-1)<(model.slbar+model.clbar));
                    iable=(la./ya.*Us(:,k,t-1)>model.slbar+model.clbar+istars(:,k,t-1));
                    %do for defaulters  (just need consumption)
                    if max(def)==1
                        dp(def==1)=0;
                        C(def==1)=model.clbar*ya(def==1)./Us(def==1,k,t-1);
                        s(def==1)=model.slbar*ya(def==1)./Us(def==1,k,t-1);
                    end
                    %do for non-investors
                    if max(iable==0 & def==0)==1
                        dp(iable==0 & def==0)=0;
                        C(iable==0 & def==0)=funeval(ccons,fspace,[(la(iable==0 & def==0)./ya(iable==0 & def==0).*Us(iable==0 & def==0,k,t-1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*ya(iable==0 & def==0)./Us(iable==0 & def==0,k,t-1);
                        s(iable==0 & def==0)=la(iable==0 & def==0)-C(iable==0 & def==0);
                    end
                    %do for potential investors
                    if max(iable)==1
                        [valfun dp(iable==1)]=max([funeval(c,fspace,[(la(iable==1)./ya(iable==1).*Us(iable==1,k,t-1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) funeval(c,fspace,[(la(iable==1)./ya(iable==1).*Us(iable==1,k,t-1)-model.slbar-model.clbar+0.01-istars(iable==1,k,t-1)).^(1-model.rho)/(1-model.rho)  istars(iable==1,k,t-1)])],[],2);
                        dp(iable==1)=dp(iable==1)-1;
                        C(iable==1)=((1-dp(iable==1)).*funeval(ccons,fspace,[(la(iable==1)./ya(iable==1).*Us(iable==1,k,t-1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) + dp(iable==1).*funeval(ccons,fspace,[(la(iable==1)./ya(iable==1).*Us(iable==1,k,t-1)-model.slbar-model.clbar+0.01-istars(iable==1,k,t-1)).^(1-model.rho)/(1-model.rho)  istars(iable==1,k,t-1)])).*ya(iable==1)./Us(iable==1,k,t-1);
                        s(iable==1)=la(iable==1)-C(iable==1)-dp(iable==1).*istars(iable==1,k,t-1).*ya(iable==1)./Us(iable==1,k,t-1);
                    end
                    Yprime(:,t,k)=(model.G*Ns(:,k,t-1)+model.R*dp.*istars(:,k,t-1)).*ya.*Us(:,k,t)./Us(:,k,t-1).*Errs(:,k,t);
                    Lprime(:,k)=s.*model.r+Yprime(:,t,k)./Errs(:,k,t);
                end
                if t<=3
                    for k=1:S
                        ya=Yprime(:,t,k)./Errs(:,k,t);
                        def=(Lprime(:,k)./ya.*Us(:,k,t)<(model.slbar+model.clbar));
                        iable=(Lprime(:,k)./ya.*Us(:,k,t)>model.slbar+model.clbar+istars(:,k,t));
                        %do for defaulters  (just need consumption)
                        if max(def)==1
                            dp(def==1)=0;
                            C(def==1)=model.clbar*ya(def==1)./Us(def==1,k,t);
                            s(def==1)=model.slbar*ya(def==1)./Us(def==1,k,t);
                        end
                        %do for non-investors
                        if max(iable==0 & def==0)==1
                            dp(iable==0 & def==0)=0;
                            C(iable==0 & def==0)=funeval(ccons,fspace,[(Lprime(iable==0 & def==0,k)./ya(iable==0 & def==0).*Us(iable==0 & def==0,k,t)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*ya(iable==0 & def==0)./Us(iable==0 & def==0,k,t);
                            s(iable==0 & def==0)=Lprime(iable==0 & def==0,k)-C(iable==0 & def==0);
                        end
                        %do for potential investors
                        if max(iable)==1
                            [valfun dp(iable==1)]=max([funeval(c,fspace,[(Lprime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) funeval(c,fspace,[(Lprime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t)-model.slbar-model.clbar+0.01-istars(iable==1,k,t)).^(1-model.rho)/(1-model.rho)  istars(iable==1,k,t)])],[],2);
                            dp(iable==1)=dp(iable==1)-1;
                            C(iable==1)=((1-dp(iable==1)).*funeval(ccons,fspace,[(Lprime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) + dp(iable==1).*funeval(ccons,fspace,[(Lprime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t)-model.slbar-model.clbar+0.01-istars(iable==1,k,t)).^(1-model.rho)/(1-model.rho)  istars(iable==1,k,t)])).*ya(iable==1)./Us(iable==1,k,t);
                            s(iable==1)=Lprime(iable==1,k)-C(iable==1)-dp(iable==1).*istars(iable==1,k,t).*ya(iable==1)./Us(iable==1,k,t);
                        end
                        %now calculate income growth
                        Y2prime(:,t,k)=(model.G*Ns(:,k,t)+model.R*dp.*istars(:,k,t)).*ya.*Us(:,k,t+1)./Us(:,k,t).*Errs(:,k,t+1);
                        L2prime(:,k)=s.*model.r+Y2prime(:,t,k)./Errs(:,k,t+1);
                    end
                    if t<=2
                        for k=1:S
                            ya=Y2prime(:,t,k)./Errs(:,k,t+1);
                            def=(L2prime(:,k)./ya.*Us(:,k,t+1)<(model.slbar+model.clbar));
                            iable=(L2prime(:,k)./ya.*Us(:,k,t+1)>model.slbar+model.clbar+istars(:,k,t+1));
                            %do for defaulters  (just need consumption)
                            if max(def)==1
                                dp(def==1)=0;
                                C(def==1)=model.clbar*ya(def==1)./Us(def==1,k,t+1);
                            end
                            %do for non-investors
                            if max(iable==0 & def==0)==1
                                dp(iable==0 & def==0)=0;
                                C(iable==0 & def==0)=funeval(ccons,fspace,[(L2prime(iable==0 & def==0,k)./ya(iable==0 & def==0).*Us(iable==0 & def==0,k,t+1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*ya(iable==0 & def==0)./Us(iable==0 & def==0,k,t+1);
                            end
                            %do for potential investors
                            if max(iable)==1
                                [valfun dp(iable==1)]=max([funeval(c,fspace,[(L2prime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t+1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) funeval(c,fspace,[(L2prime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t+1)-model.slbar-model.clbar+0.01-istars(iable==1,k,t+1)).^(1-model.rho)/(1-model.rho)  istars(iable==1,k,t+1)])],[],2);
                                dp(iable==1)=dp(iable==1)-1;
                                C(iable==1)=((1-dp(iable==1)).*funeval(ccons,fspace,[(L2prime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t+1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1,1)]) + dp(iable==1).*funeval(ccons,fspace,[(L2prime(iable==1,k)./ya(iable==1).*Us(iable==1,k,t+1)-model.slbar-model.clbar+0.01-istars(iable==1,k,t+1)).^(1-model.rho)/(1-model.rho)  istars(iable==1,k,t+1)])).*ya(iable==1)./Us(iable==1,k,t+1);
                                s(iable==1)=L2prime(iable==1,k)-C(iable==1)-dp(iable==1).*istars(iable==1,k,t+1).*ya(iable==1)./Us(iable==1,k,t+1);
                            end
                            %now calculate income growth
                            Y3prime(:,t,k)=(model.G*Ns(:,k,t+1)+model.R*dp.*istars(:,k,t+1)).*ya.*Us(:,k,t+2)./Us(:,k,t+1).*Errs(:,k,t+2);
                            L3prime(:,k)=s.*model.r+Y3prime(:,t,k)./Errs(:,k,t+2);
                        end
                    end
                end
            end
        end
    end
    for t=2:7
        for jj=1:64
            model.slbar=slbarmb(jj);
            if t>5    
                for j=1:ds
                    ya=fulldata(:,t)/Sval(j,3);
                    la=(fulldata(:,43+t)-fulldata(:,t))+ya;
                    def=(la./ya*Sval(j,1)<(model.slbar+model.clbar));
                    iable=(la./ya*Sval(j,1)>model.slbar+model.clbar+Sval(j,2));
                    %do for defaulters  (just need consumption)
                    if max(def==1 & fulldata(:,57)==jj)==1
                        Clevel(def==1 & fulldata(:,57)==jj,t,j)=model.clbar*ya(def==1 & fulldata(:,57)==jj)/Sval(j,1);
                        d(def==1 & fulldata(:,57)==jj,t,j)=0;
                    end
                    %do for non-investors
                    if max(iable==0 & def==0 & fulldata(:,57)==jj)==1
                        d(iable==0 & def==0 & fulldata(:,57)==jj,t,j)=0;
                        Clevel(iable==0 & def==0 & fulldata(:,57)==jj,t,j)=funeval(cconsmb(:,jj),fspace,[(la(iable==0 & def==0 & fulldata(:,57)==jj)./ya(iable==0 & def==0 & fulldata(:,57)==jj)*Sval(j,1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0 & fulldata(:,57)==jj,1)]).*ya(iable==0 & def==0 & fulldata(:,57)==jj)/Sval(j,1);
                    end
                    %do for potential investors
                    if max(iable==1 & fulldata(:,57)==jj)==1
                        [valfun d(iable==1 & fulldata(:,57)==jj,t,j)]=max([funeval(cmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj)*Sval(j,1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & fulldata(:,57)==jj,1)]) funeval(cmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj)*Sval(j,1)-model.slbar-model.clbar+0.01-Sval(j,2)).^(1-model.rho)/(1-model.rho)  Sval(j,2)*os(iable==1 & fulldata(:,57)==jj)])],[],2);
                        d(iable==1 & fulldata(:,57)==jj,t,j)=d(iable==1 & fulldata(:,57)==jj,t,j)-1;
                        Clevel(iable==1 & fulldata(:,57)==jj,t,j)=((1-d(iable==1 & fulldata(:,57)==jj,t,j)).*funeval(cconsmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj)*Sval(j,1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & fulldata(:,57)==jj,1)]) + d(iable==1 & fulldata(:,57)==jj,t,j).*funeval(cconsmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj)*Sval(j,1)-model.slbar-model.clbar+0.01-Sval(j,2)).^(1-model.rho)/(1-model.rho)  Sval(j,2)*os(iable==1 & fulldata(:,57)==jj)])).*ya(iable==1 & fulldata(:,57)==jj)/Sval(j,1);
                    end
                    %now calculate log investment and investment levels
                    dIlevel(fulldata(:,57)==jj,t,j)=d(fulldata(:,57)==jj,t,j).*(Sval(j,2)*ya(fulldata(:,57)==jj)/Sval(j,1));
                    EClev(fulldata(:,57)==jj,t)=EClev(fulldata(:,57)==jj,t)+Clevel(fulldata(:,57)==jj,t,j)*Sw(j);
                    Ed(fulldata(:,57)==jj,t)=Ed(fulldata(fulldata(:,57)==jj,57)==jj,t)+d(fulldata(:,57)==jj,t,j)*Sw(j);
                    EdIlev(fulldata(:,57)==jj,t)=EdIlev(fulldata(:,57)==jj,t)+dIlevel(fulldata(:,57)==jj,t,j)*Sw(j);
                end
            end
            for k=1:S
                if t==5|t==6
                   ya=fulldata(:,t)./Errs(:,k,t-1);
                   la=(fulldata(:,43+t)-fulldata(:,t))+ya;
                   def=(la./ya.*Us(:,k,t-1)<(model.slbar+model.clbar));
                   iable=(la./ya.*Us(:,k,t-1)>model.slbar+model.clbar+istars(:,k,t-1));
                   %do for defaulters  (just need consumption)
                   if max(def==1 & fulldata(:,57)==jj)==1
                       dp(def==1 & fulldata(:,57)==jj)=0;
                       C(def==1 & fulldata(:,57)==jj)=model.clbar*ya(def==1 & fulldata(:,57)==jj)./Us(def==1 & fulldata(:,57)==jj,k,t-1);
                       s(def==1 & fulldata(:,57)==jj)=model.slbar*ya(def==1 & fulldata(:,57)==jj)./Us(def==1 & fulldata(:,57)==jj,k,t-1);
                   end
                   %do for non-investors
                   if max(iable==0 & def==0 & fulldata(:,57)==jj)==1
                       dp(iable==0 & def==0 & fulldata(:,57)==jj)=0;
                       C(iable==0 & def==0 & fulldata(:,57)==jj)=funeval(cconsmb(:,jj),fspace,[(la(iable==0 & def==0 & fulldata(:,57)==jj)./ya(iable==0 & def==0 & fulldata(:,57)==jj).*Us(iable==0 & def==0 & fulldata(:,57)==jj,k,t-1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0 & fulldata(:,57)==jj,1)]).*ya(iable==0 & def==0 & fulldata(:,57)==jj)./Us(iable==0 & def==0 & fulldata(:,57)==jj,k,t-1);
                       s(iable==0 & def==0 & fulldata(:,57)==jj)=la(iable==0 & def==0 & fulldata(:,57)==jj)-C(iable==0 & def==0 & fulldata(:,57)==jj);
                   end
                   %do for potential investors
                   if max(iable==1 & fulldata(:,57)==jj)==1
                       [valfun dp(iable==1 & fulldata(:,57)==jj)]=max([funeval(cmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t-1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & fulldata(:,57)==jj,1)]) funeval(cmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t-1)-model.slbar-model.clbar+0.01-istars(iable==1 & fulldata(:,57)==jj,k,t-1)).^(1-model.rho)/(1-model.rho)  istars(iable==1 & fulldata(:,57)==jj,k,t-1)])],[],2);
                       dp(iable==1 & fulldata(:,57)==jj)=dp(iable==1 & fulldata(:,57)==jj)-1;
                       C(iable==1 & fulldata(:,57)==jj)=((1-dp(iable==1 & fulldata(:,57)==jj)).*funeval(cconsmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t-1)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & fulldata(:,57)==jj,1)]) + dp(iable==1 & fulldata(:,57)==jj).*funeval(cconsmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t-1)-model.slbar-model.clbar+0.01-istars(iable==1 & fulldata(:,57)==jj,k,t-1)).^(1-model.rho)/(1-model.rho)  istars(iable==1 & fulldata(:,57)==jj,k,t-1)])).*ya(iable==1 & fulldata(:,57)==jj)./Us(iable==1 & fulldata(:,57)==jj,k,t-1);
                       s(iable==1 & fulldata(:,57)==jj)=la(iable==1 & fulldata(:,57)==jj)-C(iable==1 & fulldata(:,57)==jj)-dp(iable==1 & fulldata(:,57)==jj).*istars(iable==1 & fulldata(:,57)==jj,k,t-1).*ya(iable==1 & fulldata(:,57)==jj)./Us(iable==1 & fulldata(:,57)==jj,k,t-1);
                   end
                   Yprime(fulldata(:,57)==jj,t,k)=(model.G*Ns(fulldata(:,57)==jj,k,t-1)+model.R*dp(fulldata(:,57)==jj).*istars(fulldata(:,57)==jj,k,t-1)).*ya(fulldata(:,57)==jj).*Us(fulldata(:,57)==jj,k,t)./Us(fulldata(:,57)==jj,k,t-1).*Errs(fulldata(:,57)==jj,k,t);
                   Lprime(fulldata(:,57)==jj,k)=s(fulldata(:,57)==jj).*model.r+Yprime(fulldata(:,57)==jj,t,k)./Errs(fulldata(:,57)==jj,k,t);
                end   
                if t==4|t==5
                    ya=Yprime(:,t,k);
                    la=Lprime(:,k);
                    def=(la./ya.*Us(:,k,t)<(model.slbar+model.clbar));
                    iable=(la./ya.*Us(:,k,t)>model.slbar+model.clbar+istars(:,k,t));
                    %do for defaulters  (just need consumption)
                    if max(def==1 & fulldata(:,57)==jj)==1
                        dp(def==1 & fulldata(:,57)==jj)=0;
                        C(def==1 & fulldata(:,57)==jj)=model.clbar*ya(def==1 & fulldata(:,57)==jj)./Us(def==1 & fulldata(:,57)==jj,k,t);
                        s(def==1 & fulldata(:,57)==jj)=model.slbar*ya(def==1 & fulldata(:,57)==jj)./Us(def==1 & fulldata(:,57)==jj,k,t);
                    end
                    %do for non-investors
                    if max(iable==0 & def==0 & fulldata(:,57)==jj)==1
                        dp(iable==0 & def==0 & fulldata(:,57)==jj)=0;
                        C(iable==0 & def==0 & fulldata(:,57)==jj)=funeval(cconsmb(:,jj),fspace,[(la(iable==0 & def==0 & fulldata(:,57)==jj)./ya(iable==0 & def==0 & fulldata(:,57)==jj).*Us(iable==0 & def==0 & fulldata(:,57)==jj,k,t)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0 & fulldata(:,57)==jj,1)]).*ya(iable==0 & def==0 & fulldata(:,57)==jj)./Us(iable==0 & def==0 & fulldata(:,57)==jj,k,t);
                        s(iable==0 & def==0 & fulldata(:,57)==jj)=la(iable==0 & def==0 & fulldata(:,57)==jj)-C(iable==0 & def==0 & fulldata(:,57)==jj);
                    end
                    %do for potential investors
                    if max(iable==1 & fulldata(:,57)==jj)==1
                        [valfun dp(iable==1 & fulldata(:,57)==jj)]=max([funeval(cmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & fulldata(:,57)==jj,1)]) funeval(cmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t)-model.slbar-model.clbar+0.01-istars(iable==1 & fulldata(:,57)==jj,k,t)).^(1-model.rho)/(1-model.rho)  istars(iable==1 & fulldata(:,57)==jj,k,t)])],[],2);
                        dp(iable==1 & fulldata(:,57)==jj)=dp(iable==1 & fulldata(:,57)==jj)-1;
                        C(iable==1 & fulldata(:,57)==jj)=((1-dp(iable==1 & fulldata(:,57)==jj)).*funeval(cconsmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & fulldata(:,57)==jj,1)]) + dp(iable==1 & fulldata(:,57)==jj).*funeval(cconsmb(:,jj),fspace,[(la(iable==1 & fulldata(:,57)==jj)./ya(iable==1 & fulldata(:,57)==jj).*Us(iable==1 & fulldata(:,57)==jj,k,t)-model.slbar-model.clbar+0.01-istars(iable==1 & fulldata(:,57)==jj,k,t)).^(1-model.rho)/(1-model.rho)  istars(iable==1 & fulldata(:,57)==jj,k,t)])).*ya(iable==1 & fulldata(:,57)==jj)./Us(iable==1 & fulldata(:,57)==jj,k,t);
                        s(iable==1 & fulldata(:,57)==jj)=la(iable==1 & fulldata(:,57)==jj)-C(iable==1 & fulldata(:,57)==jj)-dp(iable==1 & fulldata(:,57)==jj).*istars(iable==1 & fulldata(:,57)==jj,k,t).*ya(iable==1 & fulldata(:,57)==jj)./Us(iable==1 & fulldata(:,57)==jj,k,t);
                    end
                    Y2prime(fulldata(:,57)==jj,t,k)=(model.G*Ns(fulldata(:,57)==jj,k,t)+model.R*dp(fulldata(:,57)==jj).*istars(fulldata(:,57)==jj,k,t)).*ya(fulldata(:,57)==jj).*Us(fulldata(:,57)==jj,k,t+1)./Us(fulldata(:,57)==jj,k,t).*Errs(fulldata(:,57)==jj,k,t+1);
                    L2prime(fulldata(:,57)==jj,k)=s(fulldata(:,57)==jj).*model.r+Y2prime(fulldata(:,57)==jj,t,k)./Errs(fulldata(:,57)==jj,k,t+1);
               end
            end
        end
    end        
    ElnYp=mean(log(Yprime),3);
    ElnY2p=mean(log(Y2prime),3);
    ElnY3p=mean(log(Y3prime),3);
      for k=1:S
        sqdevlnYp(:,:,k)=(log(Yprime(:,:,k))-ElnYp).^2;
        sqdevlnY2p(:,:,k)=(log(Y2prime(:,:,k))-ElnY2p).^2;
        sqdevlnY3p(:,:,k)=(log(Y3prime(:,:,k))-ElnY3p).^2;
    end
    EvarlnYp=mean(sqdevlnYp,3);
    EvarlnY2p=mean(sqdevlnY2p,3);
    EvarlnY3p=mean(sqdevlnY3p,3);



    eps(:,1)=sum((fulldata(:,19:20)-(model.r-1)*(fulldata(:,25:26))),2);   %savings and credit interest moment
    eps(:,2)=sum((fulldata(:,31:32)-(model.r-1)*(fulldata(:,37:38))),2);   %savings and credit interest moment
    eps(:,3)=sum((log(fulldata(:,6))-ElnYp(:,5)),2);  %1-year growth expectation post 1
    eps(:,4)=sum((log(fulldata(:,7))-ElnYp(:,6)),2);  %1-year growth expectation post 2


    for t=2:7
        %now we construct moments
        if t<7
            devYvar1(:,t)=(log(fulldata(:,t+1))-ElnYp(:,t)+mean(log(fulldata(:,t+1))-ElnYp(:,t))).^2-EvarlnYp(:,t);  %1-year growth variance
            if t<6
                devYvar2(:,t)=(log(fulldata(:,t+2))-ElnY2p(:,t)+mean(log(fulldata(:,t+2))-ElnY2p(:,t))).^2-EvarlnY2p(:,t);  %2-year growth variance
                if t<3
                    devYvar3(:,t)=(log(fulldata(:,t+3))-ElnY3p(:,t)+mean(log(fulldata(:,t+3))-ElnY3p(:,t))).^2-EvarlnY3p(:,t);  %3-year growth variance
                end
            end
        end
        if t<6
            for k=1:S
                ya=fulldata(:,t)./Errs(:,k,t-1);
                la=(fulldata(:,43+t)-fulldata(:,t))+ya;
                if slbarbase+model.clbar>0
                    Prv(la>0,k)=logncdf((slbarbase+model.clbar)*ya(la>0)./la(la>0),0,(model.Varu).^(0.5));
                    Prv(la<=0,k)=1;
                else
                    Prv(la>0,k)=0;
                    Prv(la<=0,k)=1-logncdf((slbarbase+model.clbar)*ya(la<=0)./la(la<=0),0,(model.Varu).^(0.5));
                end
            end
        else
            for k=1:S
                ya=fulldata(:,t)./Errs(:,k,t-1);
                la=(fulldata(:,43+t)-fulldata(:,t))+ya;
                for jj=1:64
                    if slbarmb(jj)+model.clbar>0
                        Prv(la>0,k)=logncdf((slbarmb(jj)+model.clbar)*ya(la>0)./la(la>0),0,(model.Varu).^(0.5));
                        Prv(la<=0,k)=1;
                    else
                        Prv(la>0,k)=0;
                        Prv(la<=0,k)=1-logncdf((slbarmb(jj)+model.clbar)*ya(la<=0)./la(la<=0),0,(model.Varu).^(0.5));
                    end
                end
            end
        end
        Pr(:,t)=mean(Prv,2);
        devC(:,t)=(fulldata(:,49+t)-EClev(:,t));
        devD(:,t)=((fulldata(:,7+t)>1)-Ed(:,t));
        devI(:,t)=(fulldata(:,7+t)-EdIlev(:,t));
    end

    %now we construct moments

    eps(:,5)=devYvar1(:,5);  %1-year growth variance post 1
    eps(:,6)=devYvar1(:,6);  %1-year growth variance post 2
    eps(:,7)=devYvar2(:,4);  %2-year growth variance post 1
    eps(:,8)=(fulldata(:,43)-Pr(:,6)); %default moment post 1
    eps(:,9)=(fulldata(:,44)-Pr(:,7)); %default moment post 2
    eps(:,10)=devC(:,6);   %consumption post 1
    eps(:,11)=devC(:,7);   %consumption post 2
    eps(:,12)=(devC(:,6)-mean(eps(:,6))).*log(fulldata(:,6)); %cons*income post 1
    eps(:,13)=(devC(:,7)-mean(eps(:,7))).*log(fulldata(:,7)); %cons*income post 2
    eps(:,14)=((devC(:,6)-mean(eps(:,6))).*fulldata(:,49)./fulldata(:,6)); %cons*lrat post 1
    eps(:,15)=((devC(:,7)-mean(eps(:,7))).*fulldata(:,50)./fulldata(:,7)); %cons*lrat post 2
    eps(:,16)=devD(:,6); %inv. prob. post 1
    eps(:,17)=devD(:,7); %inv. prob. post 2
    eps(:,18)=((devD(:,6)-mean(eps(:,16))).*log(fulldata(:,6)));  %inv. prob.*income post 1
    eps(:,19)=((devD(:,7)-mean(eps(:,17))).*log(fulldata(:,7)));  %inv. prob.*income post 2
    eps(:,20)=((devD(:,6)-mean(eps(:,16))).*fulldata(:,49)./fulldata(:,6));  %inv. prob.*lrat post 1
    eps(:,21)=((devD(:,7)-mean(eps(:,17))).*fulldata(:,50)./fulldata(:,7));  %inv. prob.*lrat post 2
    eps(:,22)=devI(:,6); %inv. level post 1
    eps(:,23)=devI(:,7); %inv. level post 2
    eps(:,24)=((devI(:,6)-mean(eps(:,22))).*log(fulldata(:,6))); %inv. level*income post 1
    eps(:,25)=((devI(:,7)-mean(eps(:,23))).*log(fulldata(:,7))); %inv. level*income post 2
    eps(:,26)=((devI(:,6)-mean(eps(:,22))).*fulldata(:,49)./fulldata(:,6)); %inv. level*lrat post 1
    eps(:,27)=((devI(:,7)-mean(eps(:,23))).*fulldata(:,50)./fulldata(:,7)); %inv. level*lrat post 2
    for t=1:27
        eps(:,t)=eps(:,t)/sqrt(abs(var(eps(:,t))-mean(eps(:,t))^2));  %This helps with scaling computationally, but gets undone by the weighting matrix
    end
end
    epsout=mean(eps,1)
    
