%This program performs the normative evaluation in Section 5.3 by calculating the
%equivalent liquidity transfer for each household. The files uses Table5data.csv
%It calls the file solveliqinsimplex.m. The vector liqequiv holds the 
%individual data from which percentiles were calculated. The results are saved 
%in evaluationsim.mat.

!del Section53normativetransfers.txt
clear all
global model fspace Ns1 Us1 istars1 valfunmb S1 alldata Ns2 Us2 istars2 Errs2 S2 cbase os zs e2 w2

thetahat=[0.0543    1.0465    0.0977    0.1787   -0.0825    0.5211    0.9257    1.1984    1.4663    6.2612    0.0224];
R=0.11;
alldata=load('Table5data.csv');
nHH=length(alldata(:,1));
model.r=1+real(thetahat(1));
model.G=real(thetahat(2));
model.VarN=real(thetahat(3));
model.Varu=real(thetahat(4));
model.slbar=real(thetahat(5));
model.clbar=real(thetahat(6));
model.beta=real(thetahat(7));
model.rho=real(thetahat(8));
model.Eistar=real(thetahat(9));
model.Varistar=real(thetahat(10));
model.VarErr=real(thetahat(11));
model.R=R;
d=4;
%set other parameters of the model
model.maxit=300;  model.tol=0.0001;
model.dN=4;
model.du=4;
model.di=8;        % number of i points for Gaussian quadrature integration 
model.di2=model.di+1;
[model.e, model.w]=qnwlogn([model.dN,model.du,model.di],[0 0 model.Eistar],[model.VarN 0 0; 0 model.Varu 0; 0 0 model.Varistar]);
[model.istarvals, istarweight]=qnwlogn(model.di,model.Eistar,model.Varistar);
%get weights and values for u and istar for expectation calculations
%discretize the random shocks e=[N,u,istar]
model.N=model.e(:,1);
model.u=model.e(:,2);
model.istar=model.e(:,3);
model.istarvals2=[0;model.istarvals];
model.di2=length(model.istarvals2);
model.lmax=max(alldata(:,21)./alldata(:,5))*model.e(end,2);
slbarvecmb=zeros(nHH,1);

% set amount of credit
intervention=950000;
[e2, w2]=qnwlogn([8,8,2],[0 model.Eistar 0],[model.Varu 0 0; 0 model.Varistar 0; 0 0 model.VarErr]);
S2=500;
Ns2=exp(model.VarN^0.5*randn(nHH,S2,2));
Us2=exp(model.Varu^0.5*randn(nHH,S2,3));
Errs2=exp(model.VarErr^0.5*randn(nHH,S2,3));
istars2=exp(model.Varistar^0.5*randn(nHH,S2,2)+model.Eistar);
numslbar=40;  %number of grid points for evaluation
slbarbase=model.slbar;
slbargrid=linspace(model.slbar-0.0001,model.slbar-1.5,numslbar);
mbgridnum=ones(nHH,1);
valfunmb=mbgridnum;
diffhold=ones(64,1)*50000000000000000000000000;
[c ccons lccons]=solvepolicya(model);
cbase=c;
cmat=zeros(length(c),numslbar);
cconsmat=zeros(length(c),numslbar);

%define some variable sizes
zs=zeros(nHH,1);
os=ones(nHH,1);
d=zeros(nHH,1);
iable=zeros(nHH,1);
s=zeros(nHH,1);
L=s;
Y=s;
C=s;
Bbase=s;
B=s;
sb=zeros(nHH,1);
sss=zeros(nHH,1);
valholder=s;
valfunbasetemp=zeros(nHH,128);
valfunbase=s;
valfuntransftemp=zeros(nHH,128);
valfuntransf=s;
valfunmbtemp=zeros(nHH,128);
valfunmbss=s;
defaulter=zeros(nHH,128);
defaultertransf=zeros(nHH,128);
defaultermb=zeros(nHH,128);

%we'll leave data in matrix form for routines, but use this as a key:

% Y1=alldata(:,1);
% Y2=alldata(:,2);
% Y3=alldata(:,3);
% Y4=alldata(:,4);
% Y5=alldata(:,5);
% Y6=alldata(:,6);
% Y7=alldata(:,7);
% I1=alldata(:,8);
% I2=alldata(:,9);
% I3=alldata(:,10);
% I4=alldata(:,11);
% I5=alldata(:,12);
% I6=alldata(:,13);
% I7=alldata(:,14);
% DEF2=alldata(:,15);
% DEF3=alldata(:,16);
% DEF4=alldata(:,17);
% DEF5=alldata(:,18);
% DEF6=alldata(:,19);
% DEF7=alldata(:,20);
% L2=alldata(:,21);
% L3=alldata(:,22);
% L4=alldata(:,23);
% L5=alldata(:,24);
% L6=alldata(:,25);
% L7=alldata(:,26);
% C2=alldata(:,27);
% C3=alldata(:,28);
% C4=alldata(:,29);
% C5=alldata(:,30);
% C6=alldata(:,31);
% C7=alldata(:,32);
% villnum=alldata(:,33)
% villsize=alldata(:,34)

%solve model for different values of slbar
for ss=1:numslbar
     model.slbar=slbargrid(ss);
     [cmat(:,ss) cconsmat(:,ss) lccons]=solvepolicya(model);
end


%SOLVE THINGS FOR THE BASELINE
model.slbar=slbarbase;
for t=2:5
    for k=1:128
        %let's figure out 2002 predictions for different slbars
        Y=alldata(:,t);
        L=alldata(:,19+t);
        U=e2(k,1);
        ist=e2(k,2);
        UE=U*e2(k,3);
        def=(L./Y.*UE<(model.slbar+model.clbar));
        defaulter(:,k)=def;
        iable=(L./Y.*UE>=model.slbar+model.clbar+ist);
        %do for defaulters  (just need consumption)
        if max(def)==1
            sb(def==1)=model.slbar*Y(def==1)./(UE);
            if t==5
                valfunbasetemp(def==1,k)=funeval(c,fspace,[(0.01*os(def==1,1)).^(1-model.rho)/(1-model.rho)  zs(def==1,1)]).*((Y(def==1)/UE).^(1-model.rho));
            end
        end
        %do for non-investors
        if max(iable==0 & def==0)==1
            C(iable==0 & def==0)=funeval(ccons,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*Y(iable==0 & def==0)/UE;
            sb(iable==0 & def==0)=L(iable==0 & def==0)-C(iable==0 & def==0);
            if t==5
                valfunbasetemp(iable==0 & def==0,k)=funeval(c,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*((Y(iable==0 & def==0)/UE).^(1-model.rho));        
            end
        end
        %do for potential investors
        if max(iable)==1
            [valholder(iable==1 & def==0) d(iable==1 & def==0)]=max([funeval(c,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]) funeval(c,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)])],[],2);
            d(iable==1 & def==0)=d(iable==1 & def==0)-1;
            C(iable==1 & def==0)=((1-d(iable==1 & def==0)).*funeval(ccons,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]) + d(iable==1 & def==0).*funeval(ccons,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)])).*Y(iable==1 & def==0)/UE;           
            sb(iable==1 & def==0)=L(iable==1 & def==0)-C(iable==1 & def==0)-ist*d(iable==1 & def==0).*Y(iable==1 & def==0)/UE;
            if t==5
               valfunbasetemp(iable==1 & def==0,k)=valholder(iable==1 & def==0).*((Y(iable==1 & def==0)/UE).^(1-model.rho));
            end
        end         
        Bbase=Bbase-1/4*(sb<0).*sb*w2(k);
        if t==5
            valfunbase=valfunbase+valfunbasetemp(:,k)*w2(k);
        end
    end
end

%NOW WE SOLVE FOR THE BASELINE WITH AN EQUALIZED LIQUIDITY TRANSFER
for t=2:5
    for k=1:128
        %let's figure out 2002 predictions for different slbars
        Y=alldata(:,t);
        L=alldata(:,19+t)+1000000./alldata(:,34);
        U=e2(k,1);
        ist=e2(k,2);
        UE=U*e2(k,3);
        def=(L./Y.*UE<(model.slbar+model.clbar));
        defaultertransf(:,k)=def;
        iable=(L./Y.*UE>=model.slbar+model.clbar+ist);
        %do for defaulters  (just need consumption)
        if max(def)==1
            sb(def==1)=model.slbar*Y(def==1)./(UE);
            if t==5
                valfuntransftemp(def==1,k)=funeval(c,fspace,[(0.01*os(def==1,1)).^(1-model.rho)/(1-model.rho)  zs(def==1,1)]).*((Y(def==1)/UE).^(1-model.rho));
            end
        end
        %do for non-investors
        if max(iable==0 & def==0)==1
            C(iable==0 & def==0)=funeval(ccons,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*Y(iable==0 & def==0)/UE;
            sb(iable==0 & def==0)=L(iable==0 & def==0)-C(iable==0 & def==0);
            if t==5
                valfuntransftemp(iable==0 & def==0,k)=funeval(c,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*((Y(iable==0 & def==0)/UE).^(1-model.rho));        
            end
        end
        %do for potential investors
        if max(iable)==1
            [valholder(iable==1 & def==0) d(iable==1 & def==0)]=max([funeval(c,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]) funeval(c,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)])],[],2);
            d(iable==1 & def==0)=d(iable==1 & def==0)-1;
            C(iable==1 & def==0)=((1-d(iable==1 & def==0)).*funeval(ccons,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]) + d(iable==1 & def==0).*funeval(ccons,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)])).*Y(iable==1 & def==0)/UE;           
            sb(iable==1 & def==0)=L(iable==1 & def==0)-C(iable==1 & def==0)-ist*d(iable==1 & def==0).*Y(iable==1 & def==0)/UE;
            if t==5
               valfuntransftemp(iable==1 & def==0,k)=valholder(iable==1 & def==0).*((Y(iable==1 & def==0)/UE).^(1-model.rho));
            end
        end         
        if t==5
            valfuntransf=valfuntransf+valfuntransftemp(:,k)*w2(k);
        end
    end
end

%NOW WE SOLVE FOR EACH POSSIBLE ALTERNATIVE SLBAR
for ss=1:numslbar
    B=zeros(nHH,1);
    sss=zeros(nHH,1);
    valfunmbss=B;
    valfunmbtempss=zeros(nHH,128);
    model.slbar=slbargrid(ss);
    for t=2:5
        for k=1:128
            %let's figure out 2002 predictions for different slbars
            Y=alldata(:,t);
            L=alldata(:,19+t);
            U=e2(k,1);
            ist=e2(k,2);
            UE=U*e2(k,3);
            def=(L./Y.*UE<(model.slbar+model.clbar));
            defaulter2(:,k)=def;
            iable=(L./Y.*UE>model.slbar+model.clbar+ist);
            %do for defaulters  (just need consumption)
            if max(def)==1
                sss(def==1)=model.slbar*Y(def==1)./UE;
                if t==5
                    valfunmbtempss(def==1,k)=funeval(cmat(:,ss),fspace,[(0.01*os(def==1,1)).^(1-model.rho)/(1-model.rho)  zs(def==1,1)]).*((Y(def==1)/UE).^(1-model.rho));
                end
            end
            %do for non-investors
            if max(iable==0 & def==0)==1
                C(iable==0 & def==0)=funeval(cconsmat(:,ss),fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*Y(iable==0 & def==0)/UE;
                sss(iable==0 & def==0)=L(iable==0 & def==0)-C(iable==0 & def==0);
                if t==5
                    valfunmbtempss(iable==0 & def==0,k)=funeval(cmat(:,ss),fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*((Y(iable==0 & def==0)/UE).^(1-model.rho));
                end
            end
            %do for potential investors
            if max(iable)==1
                [valholder(iable==1 & def==0) d(iable==1 & def==0)]=max([funeval(cmat(:,ss),fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]) funeval(cmat(:,ss),fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)])],[],2);
                d(iable==1 & def==0)=d(iable==1 & def==0)-1;
                C(iable==1 & def==0)=((1-d(iable==1 & def==0)).*funeval(cconsmat(:,ss),fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]) + d(iable==1 & def==0).*funeval(cconsmat(:,ss),fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)])).*Y(iable==1 & def==0)./UE;           
                sss(iable==1 & def==0)=L(iable==1 & def==0)-C(iable==1 & def==0)-ist*d(iable==1 & def==0).*Y(iable==1 & def==0)/UE;
                if t==5
                    valfunmbtempss(iable==1 & def==0,k)=valholder(iable==1 & def==0).*((Y(iable==1 & def==0)./UE).^(1-model.rho));
                end
            end         
            if t==5
                valfunmbss=valfunmbss+valfunmbtempss(:,k)*w2(k);
            end
            B=B-1/4*(sss<0).*sss*w2(k);
        end
    end
    for v=1:64
         diff=mean(B-Bbase)*mean(alldata(alldata(:,33)==v,34))-intervention;
         if diff<diffhold(v)
             diffhold(v)=abs(diff);
             mbgridnum(alldata(:,33)==v)=ss;
             valfunmb(alldata(:,33)==v)=valfunmbss(alldata(:,33)==v);
             valfunmbtemp(alldata(:,33)==v,:)=valfunmbtempss(alldata(:,33)==v,:);
             defaultermb(alldata(:,33)==v,:)=defaulter2(alldata(:,33)==v,:);
             
        end
    end            
end


%THIS EVALUATES THE EQUIVALENT LIQUIDITY TRANSFER
model.slbar=slbarbase;
liqin=1.5*intervention./alldata(:,34);
[f liqequiv]=solveliqinsimplex(model,fspace,c,liqin);  %calls the simplex to find the equivalent transfer

diary Section53normativetransfers.txt
averageequivtransfer=mean(liqequiv)
mediantransfer=(slbargrid(mean(mbgridnum(alldata(:,33)==7)))-slbarbase)*87200 %average income (i.e., 87200) in the median village (i.e., village 7)
diary off

save evaluationsim;