version 7
set more off
set mem 200m
set matsize 200


*this file runs the regressions for the estimates in Table 1.  The coefficients are those on the variable invHHt.  This calls the data file Table1data.dta and produces the output file Table1.log.

use Table1data.dta, clear


*create outcome variables
by case_id: g dnetinc=log(netinc[_n+1]/netinc[_n])
g lgassd=log(gassd)
by case_id: g dlgassd1=log(gassd[_n+1]/gassd[_n])
g invprob=fbinv>0

*create log of number of households in village
by case_id: g invHHl=invHH[_n-1]
by case_id: g vfstl=vfst[_n-1]
*create dummy variables using village size
g invHHtvf1=invHH*(year==6)  
g invHHtvf2=invHH*(year==7)  
g invHHltvf2=invHHl*(year==7)
g invHHt=invHH*year*1000000
g invHHlt=invHHl*year*1000000

g double caseid=case_id
drop case_id

log using Table1.log, replace
*Table 1 presents the coefficients on invHHt;
xi: xtivreg newst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt) , fe i(caseid) first
xi: xtivreg baacst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt) , fe i(caseid)
xi: xtivreg cbst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt) , fe i(caseid)
xi: xtivreg agst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt) , fe i(caseid)
xi: xtivreg busst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt) , fe i(caseid)
xi: xtivreg frtst   i.year lac madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year lac madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt) , fe i(caseid)
xi: xtivreg const   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt) , fe i(caseid)
xi: xtivreg rst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt ) , fe i(caseid)
xi: xtivreg defi    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt), fe i(caseid)
xi: xtivreg defcr   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt ) , fe i(caseid)
xi: xtivreg infst   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2  i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt ) , fe i(caseid)
xi: xtivreg dnetinc   i.year  madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt (vfst   = invHHtvf1   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt), fe i(caseid)
xi: xtivreg busprof    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt  (vfstl  = invHHltvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt), fe i(caseid)
xi: xtivreg wageincf  i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt  (vfstl  = invHHltvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt), fe i(caseid)
xi: xtivreg riceincf    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt  (vfstl  = invHHltvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt), fe i(caseid)
xi: xtivreg cropincf    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt  (vfstl  = invHHltvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt), fe i(caseid)
xi: xtivreg liveincf    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt  (vfstl  = invHHltvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHlt), fe i(caseid)
xi: xtivreg dlgassd   i.year  madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt (vfst   = invHHtvf1   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt), fe i(caseid)
xi: xtivreg bsnew    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt), fe i(caseid)
xi: xtivreg tbinv    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh     invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt), fe i(caseid)
xi: xtivreg finv    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt), fe i(caseid)
xi: xtivreg invprob   i.year  madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt (vfst   = invHHtvf1   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt), fe i(caseid)
xi: xtivreg frtexp   i.year lac  madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt (vfst  = invHHtvf1 invHHtvf2    lac  i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg twage    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt), fe i(caseid)
xi: xtivreg tc    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt), fe i(caseid)
xi: xtivreg allc   i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh invHHt) , fe i(caseid) first
xi: xtivreg educ    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg grain    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg milk    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg meat    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg alch1    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg alch2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg fuel    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg tobac    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg cerem    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg houserep    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg vehicrep    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh    invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg clothes    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)
xi: xtivreg mealaway    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh   invHHt (vfst  = invHHtvf1 invHHtvf2    i.year madult  fadult  kids  maleh farm  ageh  age2h  educh  invHHt), fe i(caseid)

log close

